%
% demo the simulateH
% function
%
% double pendulum (each row is a separate pendulum)
%

%# global poincare ; %# contains handle for poincare figure

while 1

    T = 100.0 ;
    dT = 0.025 ; 

  choice = menu('Double pendulum',...
	      '1 tiny',...
	      '2',...
	      '3 1 small',...
	      '4',...
	      '5 big',...
	      'contin',...
	      'quit');

  %# Tperiod controls the frequency of display of state
  args = ...
	struct ( 'viewall' , 1  , ...
		'refresh' , 1  , ...
		'xmax', pi*1.05    , ...
		'alphamax', pi    , ...
		'pmax', pi , ...
		'fmax', 4 , ...
		'Kmax', 0.5 , ...
		'Vmax', 0.6 , ...
		'Hmin', 0 ,...
		'Hmax', 1.0 , ...
		'Tperiod', 0.075 , ...
		'wait', 1 , ...
		'scale' , 0 ,...
		'leapfrog', 1 , ...
		'poincare', 8 ...
		) ;

    switch choice
  case 1,
    x=[0.13 -0.13 ;  0.1341 -0.1341] ; %# 3% difference
    p=[0,0; 0,0] ;
%#    args.wait = 1 ;
    %# double pendulums
    args.xmax=0.5 ; args.pmax=0.5 ; 
    dT = 0.025 ; 
    %# energy ramps up noticeably as the simulation goes
  case 2,
    x=[0.3 -0.3 ;  0.31 -0.31] ; %# 3% difference
    p=[0,0; 0,0] ;
%#    args.wait = 1 ;
    %# double pendulums
    args.xmax=0.5 ; args.pmax=0.5 ; 
    dT = 0.00125 ; 

  case 3,
    x=[0.96 -0.96] ;
    p=[0,0] ;
    dT = 0.005 ;%# 0.01 is too large a step.
    %# double pendulums
  case 4, %# goes over the top at about 100
    x=[1.26 -1.26;1.29 -1.29] ;
    p=[0,0;0,0] ;
    dT = 0.02 ; T = 150 ; 
    %# double pendulums
  case 5,
    x=[1.66 -1.66;1.69 -1.69] ; %# the red one goes over the top at about 50
    x=[1.76 -1.76;1.79 -1.79] ; %# the red one goes over the top at about 25 cool!
    x=[1.79 -1.79;1.799 -1.799] ; %# the red one goes over the top at about 25 cool!
    p=[0,0;0,0] ;
    dT = 0.0032 ; T = 50 ; 
    %# double pendulums
  case 6,
    choice = 89 ; 
    disp 'continuing'   ;
    args.refresh = 0 ; 
  otherwise
    disp 'bye'
    break
end


switch choice
  case {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,89},
    if args.refresh
      autosetranges ; %# sets V,K,H. also sets the unused alphamax and min
    end
end
switch choice
  case {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,89},
    disp 'simulating with dT=', dT 
    [x,p] = hsimulate(x,p,T,dT,'fdoublepend',args) ;
end
end




