% (use clear all if you want to get rid)
%  clear all
 close('all','hidden')

 %# screen stuff
 
bdwidth=5; topbdwidth=30; set (0,'Units','pixels');
scnsize=get(0,'Screensize');
pos = [3/10*scnsize(3),...
       1/10*scnsize(4),...
       7/10*scnsize(3)-bdwidth,...
       9/10*scnsize(4)-(topbdwidth)];
% get a fresh figure
figure('Position',pos);


%# do them

if p7
  subplot(numx,numy,p7)
  title 'Potential energy'
  hold on
  axis([0 T -Inf Inf]);
  axis([0 T -Vmax 0.0]);
% hold off
end

if p8
  subplot(numx,numy,p8)
  hold on 
  title 'Kinetic energy'
  axis([0 T -Inf Inf]);
  axis([0 T 0 Kmax]);
% hold off
end

if p9
  subplot(numx,numy,p9)
  hold on 
  axis([0 T -Inf Inf]);
  title 'Total energy'
  axis([0 T Hmin Hmax]);
% hold off
end

if p1
  subplot(numx,numy,p1)
  hold on 
  title 'x'
  axis equal;
  %# sun plot removed to setupfigures2 (s11) and doplot2
axis([-xmax xmax -xmax xmax])
axis equal;
axis manual
% hold off
end

if p4
  subplot(numx,numy,p4)
  hold on 
  title 'x'
  axis([0 T -xmax xmax])
  axis manual
% hold off
end

if p2
  subplot(numx,numy,p2)
  hold on 
  axis([-xmax xmax -xmax xmax])
  axis equal;
  axis manual
title 'x,p'
plot(0,0,'k+')
% hold off
end

if p3
  subplot(numx,numy,p3)
  hold on 
  axis([-xmax xmax -xmax xmax])
  axis equal;
  axis manual
title 'x,force'
plot(0,0,'k+')
% hold off
end

if p5
  subplot(numx,numy,p5)
  hold on
  axis([-pmax pmax -pmax pmax])
  axis equal;
  axis manual
title 'p'
plot(0,0,'k+')
% hold off
end

if p6
  subplot(numx,numy,p6)
  hold on 
  axis([-fmax fmax -fmax fmax])
  title 'force'
  axis equal;
  axis manual
  plot(0,0,'k+')
  % hold off
end 
% handle=get(gcf,'Children') ; 


if q1
  subplot(numx,numy,q1)
  hold on 
  title 'x(relative)'
  axis equal;
  plot(0,0,'ro')
  if args.viewall == 1
    axis([-1.6*xmax 0.4*xmax -xmax xmax])
  elseif args.viewall == 0
    axis([-0.012*xmax 0.012*xmax -0.012*xmax 0.012*xmax])
  elseif args.viewall == 3
    axis([-xmax 0.1*xmax -0.1*xmax xmax])
  else %# 2
    axis([-0.2*xmax 0.2*xmax -0.2*xmax 0.2*xmax])
  end
  axis equal;
  axis manual
  % hold off
end

if q2
  subplot(numx,numy,q2)
  hold on 
  title 'p(relative)'
  axis equal;
  plot(0,0,'rx')
  if args.viewall == 1
    axis([-0.3*pmax 0.3*pmax -0.3*pmax 0.3*pmax])
  elseif args.viewall == 0
    axis([-0.3*pmax 0.3*pmax -0.3*pmax 0.3*pmax])
  elseif args.viewall == 3
    axis([-0.2*pmax 0.2*pmax -0.2*pmax 0.2*pmax])
  else %# 2
    axis([-0.3*pmax 0.3*pmax -0.3*pmax 0.3*pmax])
  end
  axis equal;
  axis manual
  % hold off
end




