function [g,h,V,K] = fdoublepend( x, p, t, args ) ;
  % Hamiltonian dynamics _for double pendulum
  % _For each pendulum d The coordinates x(d,1) and x(d,2) are
  % the alpha and beta of a double pendulum
  % alpha' = 2 (l_alpha - (1+cos(b) l_beta)) / ( 3-cos (2 beta) )
  % page 427 of finch and hand
  %
  % useful things: 
  sinalpha(:,1) = sin( x(:,1) )  ;
  sinbeta(:,1) = sin( x(:,2) )  ;
  sinalphabeta(:,1) = sin( x(:,1) + x(:,2) )  ;
  cosbeta(:,1) = cos(x(:,2) )   ;
  costwobeta(:,1) = cos(2*x(:,2) )  ;
  sintwobeta(:,1) = sin(2*x(:,2) )  ;
  %
  alphadot(:,1) = 2 * ( p(:,1) - (1+cosbeta).*p(:,2) ) ./ ( 3 - costwobeta ) ;
  alphadot(:,2) = ...
      2 * ( - (1+cosbeta).*p(:,1) + (3 + 2*cosbeta ) .* p(:,2) ) ...
      ./ ( 3 - costwobeta ) ;
  pdot (:,1) = - 2 * sinalpha - sinalphabeta ;
  pdot (:,2) = - sinalphabeta  ...
      - 2 * sinbeta .* (p(:,1)-p(:,2)).*p(:,2)./( 3 - costwobeta ) ...
      + 2*sintwobeta .* (p(:,1).^2 - 2*(1+cosbeta).*p(:,1).*p(:,2)+...
			(3+2*cosbeta ).*p(:,2).^2 )./( 3 - costwobeta ).^2 ;
  %
  g = pdot ;
  h = alphadot ;

  V(:,1) = 3.0 - ( 2*cos(x(:,1)) + cos( x(:,1) + x(:,2) )  ) ;
  K(:,1) = ( p(:,1).^2 - 2*(1+cosbeta).*p(:,1).*p(:,2)+...
			(3+2*cosbeta ).*p(:,2).^2 )./( 3 - costwobeta ) ;
  %


