% (use clear all if you want to get rid)
%  clear all
 close('all','hidden')

 %# screen stuff
 
bdwidth=5; topbdwidth=30; set (0,'Units','pixels');
scnsize=get(0,'Screensize');
pos = [1/10*scnsize(3),...
       1/10*scnsize(4),...
       9/10*scnsize(3)-bdwidth,...
       9/10*scnsize(4)-(topbdwidth)];
% get a fresh figure
figure('Position',pos);


%# do them

if p7
  subplot(numyb,numxb,p7)
  title 'Potential energy'
  hold on
  axis([0 T -Inf Inf]);
  axis([0 T 0.0 Vmax]);
% hold off
end

if p8
  subplot(numyb,numxb,p8)
  hold on 
  title 'Kinetic energy'
  axis([0 T -Inf Inf]);
%#  Kmax
  axis([0 T 0 Kmax]);
% hold off
end

if p9
  subplot(numyb,numxb,p9)
  hold on 
  axis([0 T -Inf Inf]);
  title 'Total energy'
%#  Hmax
  axis([0 T Hmin Hmax]);
% hold off
end

if args.poincare
  subplot(numy,numx,args.poincare)
  hold on 
  title 'x_2,p_2 Poincare section'
  axis equal;
  axis([-xmax xmax -pmax pmax])
  axis equal;
  axis manual
  plot(0,0,'y+')
  % hold off
end

%# state space plots
if p1
  subplot(numy,numx,p1)
  hold on 
  title 'x_1,p_1'
  axis equal;
  axis([-xmax xmax -pmax pmax])
  axis equal;
  axis manual
  plot(0,0,'y+')
% hold off
end


if p5
  subplot(numy,numx,p5)
  hold on
  axis([-xmax xmax -pmax pmax])
  axis equal;
  axis manual
  title 'x_2,p_2' %# State space of lower limb'
  plot(0,0,'y+')
% hold off
end

if p4
  subplot(numyb,numxb,p4)
  hold on 
  title 'x_1'
  axis([0 T -xmax xmax])
  axis manual
% hold off
end
if p6
  subplot(numyb,numxb,p6)
  hold on 
  axis([0 T -xmax xmax])
  title 'x_2'
  axis manual
end


if p2
  subplot(numyc,numxc,p2)
  hold on
  %# standard view for pendulum: dp 
  axis([-3.1/3 3.1/3 -2.1 1])
  axis equal;
  axis manual
  title 'double pendulum'
  plot(0,0,'y+')
% hold off
end

if p3
  subplot(numy,numx,p3)
  hold on 
  axis([-xmax xmax -xmax xmax])
  axis equal;
  axis manual
title 'x,force'
plot(0,0,'y+')
% hold off
end
if p6b
  subplot(numy,numy,p6)
  hold on 
  axis([-fmax fmax -fmax fmax])
  title 'force'
  axis equal;
  axis manual
  plot(0,0,'y+')
end 




