%# function showl(q,g)
  %# shows the lagrangian of a sequence q
  %# assume linear potential with slope g
  %# example usage: show([1,2,3,2],10);
  
  lw = 3 ; blob = 10 ;
  As = [] ; 
  time = 1 ; %# number of things done
  
  [N,M]=size(q) ;

  calculate

  makewindow ;
  %############################
  nr = 3 ; nc = 2 ;
  thisc = 1 ; thisr = 0 ; 
  %# 
  subplot(nr,nc,thisc+thisr*nc) ; %# state
  delete(gca);
  subplot(nr,nc,thisc+thisr*nc) ; %# state
  stateplot = plot( q, 'c-o' , 'LineWidth', lw,'EraseMode','xor',...
		   'MarkerSize', blob , 'MarkerEdgeColor', 'r' ) ;
  title('q(t)') ;
  hold on ; plot ( zeros(size(q)), 'y-' ) ; 
  set(gca, 'YLim' , [-1 2*max(q)] ) ; 
  modifythisplot ; 
  drawnow;
  %###############
  thisr = thisr + 1 ; 
  %#
  
  %# 
  subplot(nr,nc,thisc+thisr*nc) ; %# statedot
  delete(gca);
  subplot(nr,nc,thisc+thisr*nc) ; %# statedot
  dotplot = plot( qdot, 'm-o' , 'LineWidth', lw,'EraseMode','xor',...
		   'MarkerSize', blob , 'MarkerEdgeColor', 'g' ) ;
  title('dq/dt (t)') ;
  set (dotplot, 'XData', [1.5:1:M] ) ; 
  hold on ; plot ( zeros(size(q)), 'y-' ) ; 
  set(gca, 'YLim' , [-2*max(qdot) 2*max(qdot)] ) ; 
  modifythisplot ; 
  drawnow;
  %###############
  thisr = thisr + 1 ; 
  %#
  subplot(nr,nc,thisc+thisr*nc) ; %# 
  delete(gca);
  subplot(nr,nc,thisc+thisr*nc) ; %#
  Aplot = plot( As , 'y-o'  ); 
  title('Integral of Lagrangian') ;  
%#  set (Vplot, 'XData', [1.5:1:M] ) ;
  ran = abs(2*A) ; 
  set(gca, 'YLim' , [-0.71 0.72 ] ) ; 
  set(gca, 'XLim' , [0 timemax ] ) ; 
  set(gca, 'Color', 'b') ;
  grid on 
  drawnow;
  %###############


  nr = 4 ; nc = 2 ;
  thisc = 2 ; thisr = 0 ; 
  %# 
  %# next column
  %#
  subplot(nr,nc,thisc+thisr*nc) ; %# 
  delete(gca);
  subplot(nr,nc,thisc+thisr*nc) ; %#
%#  Vplot = stem( Vt , 'c'  ); 
  Vplot = plot( Vt, 'c-o' , 'LineWidth', lw,'EraseMode','xor',   'MarkerSize', blob , 'MarkerEdgeColor', 'r' ) ;
  title('Potential energy V(t)') ;  
%#  set (Vplot, 'XData', [1.5:1:M] ) ;
  set(gca, 'YLim' , [0 2*max(Vt)] ) ; 
  modifythisplot ; 
  drawnow;
  %###############
  thisr = thisr + 1 ; 
  %#
  subplot(nr,nc,thisc+thisr*nc) ; %# 
  delete(gca);
  subplot(nr,nc,thisc+thisr*nc) ; %# 
  %#  stem( Tt, 'm' ) ;
  Tplot =plot( Tt, 'm-o' , 'LineWidth', lw,'EraseMode','xor',  'MarkerSize', blob , 'MarkerEdgeColor', 'g' ) ;
  title('Kinetic energy T(t)') ;  
%#  set (Tplot, 'XData', [1.5:1:M] ) ;
  set(gca, 'YLim' , [0 3*max(Tt)] ) ; 
  modifythisplot ; 
  drawnow;
  %###############
  thisr = thisr + 1 ; 
  %#
  subplot(nr,nc,thisc+thisr*nc) ; %# 
  delete(gca);
  subplot(nr,nc,thisc+thisr*nc) ; %# 
  Lplot = plot( Lt, 'y-o' );
  title('Lagrangian(t)') ;  
  %#  set (Lplot, 'XData', [1.5:1:M] ) ;
  m = max(abs(Lt)) ; 
  set(gca, 'YLim' , [-3*m 3*m] ) ; 
  hold on ; plot ( zeros(size(q)), 'w-' ) ; 
  modifythisplot ; 
  drawnow;
  %###############
  thisr = thisr + 1 ; 
  %#
  subplot(nr,nc,thisc+thisr*nc) ; %# 
  delete(gca);
  subplot(nr,nc,thisc+thisr*nc) ; %# 
  Eplot = plot( Et, 'w-o' );
  title('Energy(t)') ;  
  set(gca, 'YLim' , [0 3*m] ) ; 
  modifythisplot ; 
  drawnow;
  %###############
  thisr = thisr + 1 ; 

  

  

