%# show normal modes
%# of a load of systems
%# in each demo we
%# set m -> MI and K, and the initial condn x0 and x1.
%######### initial condition x0, x1=velocity
%# the simulator is "mode".

while 1
  choice = menu('Normal modes',...
		'M=(1,1) K=(2,-1;-1,2)',...
		'3 masses',...
		'4 masses',...
		'4 masses, VARY to periodic',...
		'4 masses - periodic ',...
		'5 masses',...
		'5 masses, VARY to periodic',...
		'5 masses, periodic (ill-conditioned)',...
		'7 masses',...
		'21 masses (pluck centre)',...
		'21 masses (hit centre)',...
		'20 masses (1/7 pluck)',...
		'20 masses (1/7 hit)',...
		'21 masses (hit near end)',...
		'21 masses (sharp hit)',...
		'21 masses, one heavy',...
		'4 masses, VARY one heavy',...
		'5 masses, VARY one heavy',...
		'5 masses, VARY one heavy',...
		'5 masses, VARY K',...
		'21 masses, VARY one heavy',...
		'M=(1,1) K=(2,-0.1;-0.1,2)',...
		'M=(1,1) vary K weak',...
		'M=(1,1) vary K strong',...
		'3 masses',...
		'4 masses',...
		'5 masses',...
		'M=(10,1) K=(2,1;-1,2)',...
		'M=(10,1) K=(2,.1;-.1,2)',...
		'M=(1.1,1) K=(2,.1;-.1,2)',...
		'M=(1.2,1) K=(2,.1;-.1,2)',...
		'M=VARY; K=(2,.1;-.1,2)',...
		'5 masses, one (number 2) doubled',...
		'6 masses, two connected very strongly',...
		'13 masses, central pulse',...
		'dispersive toeplitz stuff',...
		'toeplitz mass matrix',...
		'varying mass',...
		'',...
		'',...
		'quit') ;
  global  switcher  ; %# this is incremented each time we ask for a match
  switcher = 0 ; %# this is incremented each time we ask for a match
  dt = 0.2 ; T1 = 20 ; T2 = 100 ; pausetime = 0.01 ;
  Tvary = 0 ; %# total amount of time to elapse during the vary simulation
  padpause = 0.01 ; Tpad = 40 ; dtpad = dt/T1 ;%# this dt defines
  %# how many pieces to divide Tpad into. The use of dt/T1 should make it
  %# the same as dt in the mode simulations.

  if ( switchermatches( choice ) ) 
    disp 'masses 1:1, normal coupling'
    [m,K] = standard(2,1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1 ;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '3 masses' ;
    [m,K] = standard(3,1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '4 masses' ;
    [m,K] = standard(4,1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 


  elseif ( switchermatches( choice ) ) 
    disp 'VARY K, 4'
    [m,K] = standard(4,1) ;
    K1 = K ; 
    K(1,4) = K(2,1) ; 
    K(4,1) = K(1,4) ; 
    x0=zeros(size(m));
    x1= x0; x1(1)=1 ; 
    varypausetime=0.01 ;
    vary(diag(m),K1,diag(m),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    disp '4 masses periodic' ;
    [m,K] = standard(4,1) ;
    K(1,4) = K(2,1) - 0.000001 ; 
    K(4,1) = K(1,4) - 0.000001 ; 
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 0.2;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '5 masses' ;
    [m,K] = standard(5,1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp 'VARY K, 5'
    [m,K] = standard(5,1) ;
    K1 = K ; 
    K(1,5) = K(2,1) ; 
    K(5,1) = K(1,5) ; 
    x0=zeros(size(m));
    x1= x0; x1(1)=1 ; 
    varypausetime=0.01 ;
    vary(diag(m),K1,diag(m),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    disp '5 masses (periodic) not robust?' ;
    [m,K] = standard(5,1) ;
    K(1,5) = K(2,1) ; 
    K(5,1) = K(1,5) ; 
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 0.2;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    [m,K] = standard(7,1)
    MI=diag(1 ./ m) ;
    x0=zeros(size(m));
    x1= x0;
    x1(1) = 1;
    T2 = 50 ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '21 masses, pluck initial condition' ;
    [m,K] = standard(21,1)
    MI=diag(1 ./ m) ;
    %######### initial condition x0, x1=velocity
    x0=zeros(size(m));
    x1= x0;
    x0=(0.1/1.2)*[1 2 3 4 5 6 7 8 9 10 11 10 9 8 7 6 5 4 3 2 1 ] ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '21 masses, hit 1/2 initial condition' ;
    [m,K] = standard(21,1)
    MI=diag(1 ./ m) ;
    %######### initial condition x0, x1=velocity
    x0=zeros(size(m));
    x1= x0; x1(11) = 0.41 ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '20 masses, pluck 1/7 initial condition' ;
    [m,K] = standard(20,1)
    MI=diag(1 ./ m) ;
    %######### initial condition x0, x1=velocity
    x0=zeros(size(m));
    x1= x0;
    x0=(0.1/4.2)*[6 12 18 17 16 15 14 13 12 11 10 9 8 7 6 5 4 3 2 1 ] ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '20 masses, hit 1/7 initial condition' ;
    [m,K] = standard(20,1)
    MI=diag(1 ./ m) ;
    %######### initial condition x0, x1=velocity
    x0=zeros(size(m));
    x1= x0;
    x1(3) = 1 ;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 


  elseif ( switchermatches( choice ) ) 
    disp '21 masses, hit pulse initial condition' ;
    [m,K] = standard(21,1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; 
    x1=(1/6.1)*[1 2 2 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '21 masses, sharp hit pulse initial condition' ;
    [m,K] = standard(21,1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; 
    x1=(1/6.1)*[3 3 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] ; 
%#    x1=(1/6.1)*[ 0 0 0 0 0 0 0 0 0 0 0 0 0 3 3 0 0 0 0 0 0] ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) )
    disp 'one heavy mass' ; 
    [m,K] = standard(21,1)
    m(14) = 12.0 ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m));
    x1= x0;
    x1=(1/6.1)*[1 2 2 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] ;
    T1 = T1 / 3;
    T2 = T2 / 2 ;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 


  elseif ( switchermatches( choice ) ) 
    disp 'VARY mass, 6'
    [m,K] = standard(6,1) ;
    m1=m;
    m1(4) = 60 ; 
    x0=zeros(size(m));
    x1= x0; x1(1)=1 ; 
    varypausetime=0.001 ;
    vary(diag(m),K,diag(m1),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    disp 'VARY mass, 5'
    [m,K] = standard(5,1) ;
    m1=m;
    m1(1) = 60 ; 
    x0=zeros(size(m));
    x1= x0; x1(1)=1 ; 
    varypausetime=0.01 ;
    vary(diag(m),K,diag(m1),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    disp 'VARY mass, 5'
    [m,K] = standard(5,1) ;
    m1=m;
    m1(3) = 60 ; 
    x0=zeros(size(m));
    x1= x0; x1(1)=1 ; 
    varypausetime=0.01 ;
    vary(diag(m),K,diag(m1),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    disp 'VARY K, 5'
    [m,K] = standard(5,1) ;
    K1 = K ; 
    K(2,2) = K(2,2) + 2 ; 
    K(3,2) = K(3,2) - 2 ; 
    K(2,3) = K(3,2) ; 
    K(3,3) = K(2,2) ; 
    x0=zeros(size(m));
    x1= x0; x1(1)=1 ; 
    varypausetime=0.01 ;
    vary(diag(m),K1,diag(m),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    disp 'VARY mass, 21'
    [m,K] = standard(21,1) ;
    m1=m;
    m1(16) = 16 ; 
    m1(16) = 0.000001 ; 
    x0=zeros(size(m));
    x1= x0;
    x1=(1/6.1)*[1 2 2 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] ; 
    varypausetime=0.001 ;
    vary(diag(m),K,diag(m1),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 
    
  elseif ( switchermatches( choice ) ) 
    disp 'weak coupling'
    [m,K] = standard(2,0.1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x0(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp 'VARY K (weaker coupling), 2'
    [m,K1] = standard(2,1) ;
    [m,K] = standard(2,0.01) ;
    K(1,1) = 1 - K(1,2) ;
    K(2,2) = K(1,1) ; 
    x0=zeros(size(m));
    x1= x0; x1(1)=1 ; 
    varypausetime=0.1 ;
    vary(diag(m),K1,diag(m),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    disp 'VARY K (stronger coupling), 2'
    [m,K1] = standard(2,1) ;
    K(1,1) = 11 ;
    K(1,2) = -10 ;
    K(2,1) = K(1,2) ;
    K(2,2) = K(1,1) ; 
    x0=zeros(size(m));
    x1= x0; x1(1)=1 ; 
    varypausetime=0.1 ;
    vary(diag(m),K1,diag(m),K,x0,x1,0.05,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    disp '3 masses' ;
    [m,K] = standard(3,0.1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '4 masses' ;
    [m,K] = standard(4,0.1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp '5 masses weak coupling' ;
    [m,K] = standard(5,0.1) ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp 'standard coupling, m(1)=10'
    [m,K] = standard(2,1) ;
    m(1)=10 ; 
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp 'weak coupling, m(1)=10'
    [m,K] = standard(2,0.1) ;
    m(1)=10 ; 
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp 'slightly unequal masses, and weak coupling'
    [m,K] = standard(2,0.1) ;
    m(1) = 1.1 ; 
    m(2) = 1 ; 
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp 'slightly unequal masses, and weak coupling'
    [m,K] = standard(2,0.1) ;
    m(1) = 1.2 ; 
    m(2) = 1 ; 
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    disp 'VARY mass, and weak coupling'
    [m,K] = standard(2,0.1) ;
    m1=m;
    m1(1) = 1.3 ; 
    MI=diag(1 ./ m) ;
    x0=zeros(size(m)); x1= x0; x1(1) = 1;
    varypausetime=0.01;
    vary(diag(m),K,diag(m1),K,x0,x1,dt,varypausetime,Tvary,padpause,dtpad,Tpad)  ; 

  elseif ( switchermatches( choice ) ) 
    %# ################ demo 1
    [m,K] = standard(5,1) ;
    m=[1 2 1 1 1]   ;
    MI=diag(1 ./ m) ;
    x0=zeros(size(m));
    x1= x0;
    x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    %# ################ demo 1
    [m,K] = standard(6,1) ;
    K(2,2) = K(2,2) + 10 ; 
    K(3,2) = K(3,2) - 10 ; 
    K(2,3) = K(3,2) ; 
    K(3,3) = K(2,2) ; 
    MI=diag(1 ./ m) ;
    x0=zeros(size(m));
    x1= x0;
    x1(1) = 1;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    %# ################ demo 1
    [m,K] = standard(13,1)
    MI=diag(1 ./ m) ;
    %######### initial condition x0, x1=velocity
    x0=zeros(size(m));
    x1= x0;
    x0(7) = 1;
    x0(6) = 0.61;
    x0(8) = 0.61;
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ;
    
  elseif ( switchermatches( choice ) ) 
    dt = 0.2 ; T1 = 40 ; T2 = 200 ; 
    %# ################ demo 1 penalise second derivative and first too.
    %# this makes the impulse sit and wobble for a long time before propagating.
    K = toeplitz( [10 -ones(1,10) zeros(1,10) ]) ... 
	+ toeplitz( [5 -ones(1,5) zeros(1,15) ]) ;
    [m,K] = dispersive(21,0.8*2/3+0.2,0.8*-1/6);
    [m,K] = dispersive(21,2/3+0.2,-1/6)
    [m,K] = dispersive(21,0.21,-0.01);
    MI=diag(1 ./ m) ;
    %######### initial condition x0, x1=velocity
    x0=zeros(size(m));
    x1= x0;
    x1=(1/6.1)*[1 2 2 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    %# # fancy M, straight K
    dt = 0.2 ; T1 = 40 ; T2 = 200 ; 
    K = eye(21) ;
    M = toeplitz( [2 0.81  zeros(1,19) ]) ;
    
    MI= inv(M) ;
    %######### initial condition x0, x1=velocity
    x0=zeros(1,21);
    x1= x0;
    x1=(1/6.1)*[1 2 2 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ; 

  elseif ( switchermatches( choice ) ) 
    dt = 0.2 ; T1 = 40 ; T2 = 200 ; 

    %# ################ demo 1
    [m,K] = standard(21,1)
    m=[1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 ] ; 
    MI=diag(1 ./ m) ;
    %######### initial condition x0, x1=velocity
    x0=zeros(size(m));
    x1= x0;
    x1=(1/6.1)*[1 2 2 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] ; 
    mode(MI*K,x0,x1,dt,T1,T2,pausetime) ;
    
    
  else
    disp 'bye' ;
    break ; 
  end
  %# end of if
  disp 'menu:' ; %#   pause
  
end
%# end of while

