  [N,junk] =size(A);
  %# find all left and right eigs
  [e,v] = eigs(A,N) ;
  [el,vl] = eigs(A',N) ;
  %# each column of e is an eig. they are unit vectors.

  omega=sqrt(diag(v)) ;

  %# project initial condition onto the eigs
  %# first find the metric. (which will be a vector of +/- 1's if A
  %# is symmetric, and less than 1's otherwise.
  %# standardize the sign of the eigs too.
  for n=1:N
    if( e(1,n) < 0.0 )
      e(:,n) = -e(:,n);
    end
    if( el(1,n) < 0.0 )
      el(:,n) = -el(:,n);
    end
    metric(n) = el(:,n)' * e(:,n)  ;
  end
  metric


  if (zeroends) 
    %# pad out e with extra zeroes for plotting purposes.
    ep = [ zeros(1,N) ; e ; zeros(1,N) ] ;
    x0p = [ 0 , x0 , 0 ] ; 
    x1p = [ 0 , x1 , 0 ] ; 
  else
    ep = e ;    x0p = x0 ;    x1p = x1 ; 
  end

  %# then productify.  x0a is x0 in the eigenvector basis
  x0a  = el' * x0' ;
  x1aw = el' * x1' ;
  x0a  = x0a  ./ metric' ;
  x1aw = x1aw ./ metric' ;
  %				# recover the omega-independent coords
  x1a = x1aw ./ omega ;
  %# and obtain the omega-multipled coordinates too
  x0aw = x0a .* omega ;

  %# use y0 and y1 to denote the current state in a, and x0s and x1s in real
  %# space
  y0a = x0a ; y1a = x1aw ; %# yes, y1a should be scaled by omega
  
  %# and reconstruct the state
  reconstruct ; %# produces x0s and x1s from y0a and y1a
