%# finddx
%# compute the relative distance of x2 from x1 in x1's frame
%# and do the sun too.
%# and the p of each also

ux = x(1,:) ; %# find the unit vector for planet 1 assuming that it's in orbit about 0,0
xs = ux*ux' ;
ux = ux/sqrt(xs) ;
sizex1 = sqrt(xs) ; 
R = [ux(1),-ux(2) ;...
     ux(2),ux(1)] ;
%# R rotates everything back into the frame in which planet 1 is 'stationary' on x-axis
dx(2,:) = ( x(2,:)-x(1,:) ) * R ;

ux = x(2,:) ; %# find the unit vector for planet 2
xs = ux*ux' ;
ux = ux/sqrt(xs) ;
sizex2 = sqrt(xs) ;
R2 = [ux(1),-ux(2) ;...
      ux(2),ux(1)] ;
%# rotate planet1's momentum into the planet 2 position
p2corotatingsunframe = ( sizex2 / sizex1 ) *  p(1,:) * R * R2' ; %# find what p2 would be if it were rotating perfectly
dp(2,:) = ( p(2,:)-p2corotatingsunframe ) * R ;

%	# This is where we store the sun: dx(1,:)
if args.threebody > 1 
  dx(1,:) = (-x(1,:)) * R * (1.0 + args.jupiter) ;
else
  dx(1,:) = (-x(1,:)) * R ;
end


