% (use clear all if you want to get rid)
%  clear all
%#
%# the variables p7 etc are defined in picturedefns
%#
 close('all','hidden')

 %# screen stuff
 
bdwidth=5; topbdwidth=10; set (0,'Units','pixels');
scnsize=get(0,'Screensize');
pos = [1/20*scnsize(3),...
       1/20*scnsize(4),...
       19/20*scnsize(3)-bdwidth,...
       19/20*scnsize(4)-(topbdwidth)];
% get a fresh figure
mainfig = figure('Position',pos);
set(mainfig,'Color',[0.1 0.34 0.34]);

%# do them

if p7
  sp7 =   subplot(numxb,numyb,p7) ;
  title 'Potential energy'
  hold on
  modifythisplot 
  axis([0 T -Inf Inf]);
  axis([0 T -Vmax 0.0]);
% hold off
end

if p8
  subplot(numxb,numyb,p8)
  hold on 
  modifythisplot 
  title 'Kinetic energy'
  axis([0 T -Inf Inf]);
  axis([0 T 0 Kmax]);
% hold off
end

if p9
  subplot(numxb,numyb,p9)
  hold on 
modifythisplot
  axis([0 T -Inf Inf]);
  title 'Total energy'
  axis([0 T Hmin Hmax]);
% hold off
end

%# numx,numy = 2x2 for the top row
if p1
  subplot(numx,numy,p1)
  hold on 
  title 'x'
modifythisplot
  axis equal;
  %# sun plot removed to setupfigures2 (s11) and doplot2
axis([-xmax xmax -xmax xmax])
axis equal;
axis manual
% hold off
end

if p4
  subplot(numxb,numyb,p4)
  hold on 
modifythisplot
  title 'x'
  axis([0 T -xmax xmax])
  axis manual
% hold off
end

if p2
  subplot(numxb,numyb,p2)
  hold on 
modifythisplot
  axis([-xmax xmax -xmax xmax])
  axis equal;
  axis manual
title 'x,p'
plot(0,0,suncolor)
% hold off
end

if p3
  subplot(numxb,numyb,p3)
  hold on 
modifythisplot
  axis([-xmax xmax -xmax xmax])
  axis equal;
  axis manual
title 'x,force'
plot(0,0,suncolor) 
% hold off
end

if p5
  subplot(numxb,numyb,p5)
  hold on
modifythisplot
  axis([-pmax pmax -pmax pmax])
  axis equal;
  axis manual
title 'p'
plot(0,0,suncolor)
% hold off
end

if p6
  subplot(numxb,numyb,p6)
  hold on 
modifythisplot 
  axis([-fmax fmax -fmax fmax])
  title 'force'
  axis equal;
  axis manual
  plot(0,0,suncolor)
  % hold off
end 
% handle=get(gcf,'Children') ; 

%# the low resolution x(relative) plot goes alongside p(relative)
if q1l
  subplot(numxb,numyb,q1l)
  hold on 
  title 'x(relative)'
  modifythisplot
  axis equal;
  plot(0,0,'o','Color',redcolor)
  axis([-1.6*xmax 0.4*xmax -xmax xmax])
  axis equal;
  axis manual
  % hold off
end

%# whether to have a high-resolution plot too
if q1
  subplot(numx,numy,q1)
  hold on 
  title 'x(relative)'
  modifythisplot
  axis equal;
  plot(0,0,'o','Color',redcolor)
  disp 'setting axis'
  args.viewall
  if args.viewall == 1
    axis([-0.4*xmax 0.4*xmax -0.4*xmax 0.4*xmax])
  elseif args.viewall == 0
    axis([-0.036*xmax 0.036*xmax -0.036*xmax 0.036*xmax])
  elseif args.viewall == 3
%#    axis([-xmax 0.1*xmax -0.1*xmax xmax])
    axis([-0.12*xmax 0.12*xmax -0.12*xmax 0.12*xmax])
  elseif args.viewall == 4 %#  used by L5 demo
    axis([-1.1*xmax 0.1*xmax -0.2*xmax xmax])
  else %# 2
    axis([-0.12*xmax 0.12*xmax -0.12*xmax 0.12*xmax])
  end
  axis equal;
  axis manual
  % hold off
end 


if q2
  subplot(numxb,numyb,q2)
  hold on 
  modifythisplot
  title 'p(relative)'
  axis equal;
  plot(0,0,'x','Color',redcolor)
  if args.viewall == 1
    axis([-0.3*pmax 0.3*pmax -0.3*pmax 0.3*pmax])
  elseif args.viewall == 0
    axis([-0.3*pmax 0.3*pmax -0.3*pmax 0.3*pmax])
  elseif args.viewall == 3
    axis([-0.2*pmax 0.2*pmax -0.2*pmax 0.2*pmax])
  else 
    axis([-0.3*pmax 0.3*pmax -0.3*pmax 0.3*pmax])
  end
  axis equal;
  axis manual
  % hold off
end








