makewindow ;
% figure(1);
hold off
J = 10 ; E = 17.5 ;
steps = 11;

I1 = 8
I2 = 6
I3 = 4
wmin = J/I1 ; 
wmax = J/I3 ;
Emin = J*J/I1 ;
Emax = J*J/I3 ;

disp 'Energy constraint is sum Iw^2 = E'
disp 'J constraint is sum I^2 w^2 = J^2'
disp 'for the given J, only E in range '
[  Emin,Emax]
disp 'are possible'

[X,Y,Z]=sphere(5) ;
Jr = [1/I1, 1/I2,1/I3 ] * (J ) ;
if (steps>1) 
  dE = (Emax - Emin ) / (steps+1) ;
end
ra = 2.05 ;
colortweak = 1.84 ;
for E = Emin+dE:dE:Emax-dE

  r =  sqrt( [1/I1, 1/I2,1/I3 ]) * sqrt(E)  ;

nx=2 ; ny = 2 ;
mapp = [1 4 3 2];
for subfig=1:4
  subplot(nx,ny,mapp(subfig)) 
  hold off
  h = surf(r(1)*X,r(2)*Y,r(3)*Z,-abs(Z)-colortweak) ;
  set (h,'FaceColor',[0.7 1 0],...
       'BackFaceLighting','lit')
  set ( h, 'EdgeColor', [0.05 1 0] )
  axis( [ -ra ,ra , -ra,  ra,  -ra,  ra ] ) ;
  switch subfig
    case {1,4},
      view([-85,15])
    case 2,
      view([-5,15])
    case 3,
      view([-85,80])
  end
  set(gca,'PlotBoxAspectRatio',[1 1 1])
  hold on
  if (subfig < 4) 
    h2 =   surf(Jr(1)*X,Jr(2)*Y,Jr(3)*Z,abs(Z)+colortweak) ;
    set (h2,'FaceColor',[0 1 1])
    % ,...       'BackFaceLighting','lit')
    set ( h2, 'EdgeColor', [0 0.5 0.5] )
  end
  colormap(summer)
  %  colormap(hsv)

  %# add lighting
  light('Position',[-2,2,20])
  lighting phong
  material([0.4,0.6,0.5,30])
  grid off 

  
end
pause  

end
    
    
